#include <bits/stdc++.h>

using namespace std;

int main() {
    // maksim
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    
    int ukup = 0, levi = -1, h, n;
    cin >> h >> n;
    int vodopad[h+1][n+1], v[h+1][n+1];
    for(int j = 1; j <= n; j++)
    {
        v[0][j] = 1;
    }
    for(int i = 1; i <= h; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            cin >> vodopad[i][j];
            v[i][j] = 0;
        }
    }
    
    for(int i = 1; i <= h; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            // da li je kamen?
            if(vodopad[i][j] == 0)
            {
                ukup = ukup + v[i-1][j];
                // da li je desno?
                if(j == n)
                {
                    v[i][levi] = v[i][levi] + ukup;
                }
            }
            else
            {
                // da li je kraj reda kamenja
                if(ukup != 0)
                {
                    // da li nema levi?
                    if(levi == -1)
                    {
                        v[i][j] = v[i][j] + ukup;
                    }
                    else
                    {
                        // paran ili ne paran?
                        if(ukup % 2 == 1)
                        {
                            // red paran ili ne paran
                            if(i % 2 == 1)
                            {
                                v[i][levi]++;
                            }
                            else
                            {
                                v[i][j]++;
                            }
                            ukup--;
                        }
                        v[i][levi] = v[i][levi] + ukup / 2;
                        v[i][j] = v[i][j] + ukup/2;
                    }
                    ukup = 0;
                }
                v[i][j] = v[i][j] + v[i-1][j];
                levi = j;
            }
        }
        ukup = 0;
        levi = -1;
    }
    for(int i = 1; i <= n; i++)
    {
        cout << v[h][i] << " ";
    }
    
}